package fr.uca.iut.config;

import com.mongodb.client.MongoClient;
import com.mongodb.client.MongoClients;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.enterprise.inject.Disposes;
import jakarta.enterprise.inject.Produces;
import org.eclipse.microprofile.config.inject.ConfigProperty;

@ApplicationScoped
public class MongoClientProvider {

    @ConfigProperty(name = "quarkus.mongodb.connection-string")
    String CONNECTION_STRING;
    @Produces
    @ApplicationScoped
    public MongoClient createMongoClient() {
        return MongoClients.create(CONNECTION_STRING);
    }

    public void close(@Disposes MongoClient client) {
        client.close();
    }
}
